#include "../includes/main.h"

// l'initialisation est temporaire, je ne savais pas comment tu voulais la faire

// initialisation des travaux 
Offre *initTabTravaux(void)
{
    Offre *tabTravaux; 
    
    tabTravaux = (Offre *)malloc(TMAXTRAV* sizeof(Offre));
    if (!tabTravaux)
    {
        printf("\033[0;31mErreur: \033[0mmalloc tableau tabTravaux\n");
        exit(1);
    }

    // Initialisation de chaque élément du tableau
    tabTravaux[0] = newOffre("Electricite");
    tabTravaux[1] = newOffre("Finitions");
    tabTravaux[2] = newOffre("Fondation");
    tabTravaux[3] = newOffre("Murs");
    tabTravaux[4] = newOffre("Peinture");
    tabTravaux[5] = newOffre("Plomberie");
    tabTravaux[6] = newOffre("Sols");
    tabTravaux[7] = newOffre("Structure");

    return (tabTravaux);
} 

/*---------------devis---------------*/

// Chargement d'une chaine de caracteres depuis un fichier
char *readFromFile(FILE *file)
{
    char	*str;
    char	*buf;
    int	len = 0;
    int	size = 5;
    int	add = 5;

    str = malloc(size);
    if (!str)
        exit(1);

    while (str[len] != '\n')
    {
        len = strlen(str);
        if (len >= size - 1)
        {
            size += add;
            buf = realloc(str, size);
            if (!buf)
            {
                free(str);
                exit(1);
            }
            str = buf;
        }
        fgets(str + len, size - len, file);
        len = strlen(str) - 1;
    }
    str[len] = '\0';
    return (str);
}

// Chargement d'un devis depuis un fichier
Devis loadDevis(FILE *devisFile, Offre *tabTravaux)
{
    int	index;
    char	*travaux;
    Devis	d;
    MaillonDevis	*nouveauMaillon;

    travaux = readFromFile(devisFile); // Meilleur moyen car on perd 8 places de char dans des tab, contre 26 si tab statique
    index = rechTravaux(travaux, tabTravaux);
    if (index == -1)
        exit(1);

    nouveauMaillon = (MaillonDevis *)malloc(sizeof(MaillonDevis));
    if (!nouveauMaillon)
    {
        printf("\033[0;31mErreur: \033[0mallocation mémoire pour nouveauMaillon\n");
        exit(1);
    }
    d.nomE = readFromFile(devisFile);
    d.adresse = readFromFile(devisFile);
    fscanf(devisFile, "%d\n%d\n%d%*c", &d.capital, &d.duree, &d.prix);
    nouveauMaillon->dev = d;
    tabTravaux[index].ldevis = insert(tabTravaux[index].ldevis, d);

    return d;
}

// Chagement des offres depuis le fichier devis.txt
Offre *loadOffre(void)
{
    Offre	*tabTravaux = initTabTravaux();

    FILE	*devisFile;

    devisFile = fopen("files/devis.txt", "r");
    if (!devisFile)
        exit(1);

    while (!feof(devisFile))
        loadDevis(devisFile, tabTravaux);

    return (tabTravaux);
}

/*-----------------precedences----------------------*/

// Chargement des tâches depuis un fichier pour chaque offre
Tache **loadTaches(Offre *tabTravaux[])
{
	Precedence *prec;
	int i, tmaxPrec=5, tlogPrec;
	Tache *t, **tabTache;
	tabTache = (Tache **)malloc(8*sizeof(Tache *));
	if (tabTache == NULL)
	{
		printf("\033[0;31mErreur: \033[0mmalloc tableau tache\n");
		exit(1);
	}
	for (i=0; i<TMAXTRAV; i++)
	{
		t=(Tache *)malloc(sizeof(Tache));
		if (t==NULL)
		{
			printf("\033[0;31mErreur: \033[0mmalloc tache\n");
			exit(1);
		}

		strcpy(t->tache, tabTravaux[i]->travaux);
		t->duree = ((tabTravaux[i]->ldevis)->dev).duree;

		prec = loadPrec(&tmaxPrec, &tlogPrec);

		t->nbPred = nombrePred(tabTravaux[i]->travaux, prec, tlogPrec);
		t->succ = 	lstSucc(tabTravaux[i]->travaux, prec, tlogPrec);

		t->dateDebut=0;
		t->traite=0;

		tabTache[i] = t; 
	}
	return tabTache;
}

/*--------------precedences--------------*/

// Chargement des précédences depuis un fichier
Precedence *loadPrec(int *tmax, int *tlog)
{
	FILE *prec;
	Precedence *tabP, *s;
	prec=fopen("../files/précédence.txt", "r");
	if (prec == NULL)
	{
		printf("\033[0;31mErreur: \033[0mouverture de 'précédence.txt'\n");
		exit(1);
	}
	tabP = (Precedence *)malloc((*tmax) * sizeof(Precedence));
	while(!feof(prec))
	{
		if(*tlog==*tmax)
		{
			(*tmax)+=5;
			s = (Precedence *)malloc((*tmax) * sizeof(Precedence));
			if (s==NULL)
			{
				printf("\033[0;31mErreur: \033[0mreallocation pour fichier précédence\n");
				exit(1);
			}
			tabP = s;
		}
		fscanf(prec, "%s%s", tabP[*tlog-1].travauxPrec, tabP[*tlog-1].travauxSucc);
		(*tlog)++;
	}
	fclose(prec);
	return tabP;
}
